#ifndef KYPTA_STRATEGY_H
#define KYPTA_STRATEGY_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class KyptaStrategy : public Strategy { //zmente jmeno tridy 
public:

  KyptaStrategy()  { reset(); }; 

  virtual int operator()() { 
    
    // dopiste vlastni strategii 

    return   last; // nebo COOPERATE;
  } 

  virtual void reward(int _reward) {
  	switch(_reward)
	{
	case CC:
		last = COOPERATE;
		break;
	case DC:
		last = DECEIVE;
		break;
	case CD:
		last = rand()%2==0 ? COOPERATE : DECEIVE;
		break;
	case DD:
		last = rand()%2==0 ? COOPERATE : DECEIVE;
		break;
	}
	/*
  	 if (_reward == CC || _reward == DC) 
	 	last = DECEIVE;
	 else if(rand()%6 > 0)
	 	last = DECEIVE;
	 else 
	 	last = COOPERATE;
	*/
  };     // informace o vysledku soubouje (CC/CD/DC/DD)
  virtual void reset() { srand(time(0)); 
  	 if(rand()%3 > 0)
	 	last = DECEIVE;
	 else 
	 	last = COOPERATE;
  };
 

  virtual string getName() { return "Kypta"; }  // pojmenujte si ji 
private:
  int last;
}; 



#endif 
