#ifndef alcapone_H
#define alcapone_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 

class AlCaponeStrategy : public Strategy { //zmente jmeno tridy 
public:

  virtual int operator()() { 
	double value = 0;
	for (int i = 3; i >= 0; i--) {
		int tah = lastFour[i];
		switch (tah) {
			case CD:
			value += (i+0.1)*(C+2*D);
			break;
			case CC:
			value += (i+0.1)*(C);
			break;
			case DD:
			value += (i+0.1)*(D*1.1);
			break;
			case DC:
			value += (i+0.1)*(2*C);
			break;
			default:
			break;
		} 
	}    
	
	if (value > 9) 
		return   DECEIVE; // nebo COOPERATE;
	else 
		return COOPERATE;
  } 

  virtual void reward(int _reward) {     // informace o vysledku soubouje (CC/CD/DC/DD)
	for (int i = 0; i < 3; i++) {
		lastFour[i] = lastFour[i+1];
	}  	
	lastFour[3] = _reward;
  };
  
  
  virtual void reset() { lastFour[0] = CD; lastFour[1] = CC; lastFour[2] = CC; lastFour[3] = DD; D = 1.5; C = 0.8; }
  virtual string getName() { return "AlCapone"; }  // pojmenujte si ji  

  private:
	 double D;
  	 double C;
	 int lastFour[4];

}; 



#endif 
