#ifndef EV_STRATEGY_H
#define EV_STRATEGY_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 

#define DRAND()	  (((double) rand()) / ( RAND_MAX + 1.0))


class EvelinaStrategy : public Strategy { 
public:
  EvelinaStrategy() { reset();
  }
  
  virtual int operator()() { 
    switch (my_last)
    {
    case COOPERATE:
      if (last == DECEIVE && deceive_prob > coop_prob){
	return DECEIVE;
      } else if (last == COOPERATE && coop_prob > deceive_prob) {
	return COOPERATE;
      } else {
	if (last == DECEIVE)
	    if (DRAND() > coop_prob) return DECEIVE; else return COOPERATE;
	else
	    if (DRAND() > deceive_prob) return COOPERATE; else return DECEIVE;
      }
    case DECEIVE:
      if (coop_prob > deceive_prob*2) {
	if (DRAND() > deceive_prob) return COOPERATE; 
      }
      return  DECEIVE;
    }
    return DECEIVE;
  } 
  
  virtual void reward(int _reward) 
  {
    n++;
    switch (_reward)
    {
	case CC:
		last = COOPERATE;
		n_coop++;
		my_last = COOPERATE;
		break;
	case DC:
		last = COOPERATE;
		n_coop++;
		my_last = DECEIVE;
		break;
	case CD:
		last = DECEIVE;
		n_deceive++;
		my_last = COOPERATE;
		break;
	case DD:
		last = DECEIVE;
		n_deceive++;
		my_last = DECEIVE;
		break;
    }

    deceive_prob = (double)n_deceive / (double)n;
    coop_prob = (double)n_coop / (double)n;
  };     // informace o vysledku soubouje (CC/CD/DC/DD)

 virtual void reset() {
	last = COOPERATE;
	my_last = COOPERATE;
	deceive_prob = 0.1;
 	n_deceive = 0;
	coop_prob = 0.9;
	n_coop = 0;
	n = 0;
   }


  virtual string getName() { return "EvelinaStrategy"; }  // pojmenujte si ji  

private:
   int last;
   int my_last;
   double deceive_prob;
   int n_deceive;
   double coop_prob;
   int n_coop;
   int n;
}; 


#endif 
