#ifndef HIP_STRATEGY_H
#define HIP_STRATEGY_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class HipStrategy : public Strategy {
private:
  int nalada;
public:

  virtual int operator()() { 
  	 if (nalada<0){
 			return DECEIVE;
  	 };
  	 if (nalada==0){
 			return COOPERATE;
  	 };
  	 if (nalada>0){
 			return COOPERATE;
  	 }
  	 return DECEIVE;
  };

  virtual void reward(int _reward) {     // informace o vysledku soubouje (CC/CD/DC/DD)
  		switch(_reward){
  			case CC:	//vsechno je v nejlepsim poradku
//  				++nalada;
//  				if(nalada>5){	//zkus neco nahrabat .. obcas praskni
//  					nalada=-1;
//  				}
				
  				nalada=0;
	  			break;
  			case CD:	//podrazil me
//  				if(nalada>0)	//parkrat mu to oplat
//  					nalada=0;
//  				nalada-=2;				
  				
  				nalada=-1;		//jeho smula
	  			break;
  			case DD:	//byli jsme oba zly

				nalada=-1;  	//fajn, taky cesta
	  			break;
  			case DC:	//byl jsem zly
//  				nalada=2;	//tak to s nim zkus
  				
  				nalada=-1;		//nene, ja nezapominam
	  			break;
	  		default:
	  			break;
  		};
  };

  virtual void reset(){ nalada=0; }

  virtual string getName() { return "Hip"; }
}; 



#endif 
