#ifndef LU_STRATEGY_H
#define LU_STRATEGY_H

#include "../strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class JesteLepsiStrategie : public Strategy { //zmente jmeno tridy 
public:

  virtual int operator()() { 
    
    // dopiste vlastni strategii 
	 if (avgMy >= avgHis) {
		last_action = COOPERATE;	 
	 } else 
	 	last_action = DECEIVE;
    return last_action; // nebo COOPERATE;
  } 

  virtual void reward(int _reward) {
  		avgMy = (0.9*cnt *avgMy + _reward)/(cnt+1);
  		int hisReward = _reward;
  		if(_reward == CD)
  			hisReward = DC;
  		if(_reward == DC)
  			hisReward = CD;
  			
  		avgHis = (0.9*cnt*avgHis + hisReward)/(cnt+1);
  		cnt++;
  };     // informace o vysledku soubouje (CC/CD/DC/DD)

  virtual void reset() { last_reward = CC; llast_reward = CC;
  	cnt = 0;
  	avgMy = 0;
  	avgHis = 0;
  }

  virtual string getName() { return "JesteLepsiStrategie"; }  // pojmenujte si ji  
  
  private:
  	int last_reward, llast_reward, last_action;
  	double avgMy;
  	double avgHis;
  	int cnt;
}; 



#endif 
