#ifndef LU_STRATEGY_H
#define LU_STRATEGY_H

#include "strategy.h"
#include <math.h>

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class JesteLepsiStrategie : public Strategy { //zmente jmeno tridy 
public:
	
	JesteLepsiStrategie() { reset(); }	
	
  virtual int operator()() {     
    // dopiste vlastni strategii 
	 if (avgMy >= avgHis-Prah) {
		last_action = COOPERATE;	 
	 } else 
	 	last_action = DECEIVE;
	 	
	if (rand()%100<4) last_action = DECEIVE;	 	
	 	
    return last_action; // nebo COOPERATE;
  } 

  virtual void reward(int _reward) {
  		avgMy = (Zapomneni*Memory *avgMy + _reward)/Memory;
  		MyRs[index] = _reward;
  		if(_reward == CD)
  			HisRs[index] = DC;
  		if(_reward == DC)
  			HisRs[index] = CD;
  			
  		avgHis = (Zapomneni*Memory*avgHis + HisRs[index])/Memory;
  		
  		index = (index+1)%Memory;
  		
		// optimalizace parametru
		int Zlepseni, ZlepseniZ, ZlepseniP, H1, H2, H3, H4, hl_iterace, iterace;
		double Min, Max;
		Zlepseni = 1;
		//cout << "jdu do cyklu zlepsovani" << endl;
		hl_iterace = 0;
		while (Zlepseni && hl_iterace < 5) {
			hl_iterace++;
			// zlepsi Zapomneni
			Min = 0.5*Zapomneni;
			Max = min(2*Zapomneni,1.0);
			ZlepseniZ = 0;
			iterace = 0;
			do {
				iterace++;
				//cout << "zlepsuju Zapomneni " << iterace << " : " << Zapomneni << endl;
				H1 = vycisli(Min, Prah);
				H2 = vycisli(Min + (Max-Min)/3, Prah);
				H3 = vycisli(Min + (Max-Min)*2/3, Prah);
				H4 = vycisli(Max, Prah);
				if (H1 == H2 and H2 == H3 and H3 == H4) {
						break;					
					}
				else if (H2 >= H1 and H2 >= H3 and H2 >= H4) {
					// hledam dal mezi 1 a 3
					Max = Min + (Max-Min)*2/3;
					//cout << "posunuju 1" << endl;
				}
				else if (H3 >= H1 and H3 >= H2 and H3 >= H4) {
					// hledam dal mezi 2 a 4
					Min = Min + (Max-Min)/3;
					//cout << "posunuju 2" << endl;
				}
				else if (H1 >= H2 and H1 >= H3 and H1 >= H4) {
					// hledam dal mezi 1 a 2
					Max = Min + (Max-Min)/3;
					//cout << "posunuju 3" << endl;
				}
				else if (H4 >= H1 and H4 >= H2 and H4 >= H3) {
					// hledam dal mezi 3 a 4
					Min = Min + (Max-Min)*2/3;
					//cout << "posunuju 4" << endl;
				}
				ZlepseniZ = 1;
				
				//cout << "novy interval: " << Min << "  -  " << Max << endl;
							
			} while (ZlepseniZ && iterace < 20);
			Zapomneni = (Min+Max)/2;
			
			// zlepsi prah		
			Min = 0.5*Prah;
			Max = min(2*Prah, 3.0);

			iterace = 0;			
			ZlepseniP = 0;
			do {
				iterace++;
				H1 = vycisli(Zapomneni, Min);
				H2 = vycisli(Zapomneni, Min + (Max-Min)/3);
				H3 = vycisli(Zapomneni, Min + (Max-Min)*2/3);
				H4 = vycisli(Zapomneni, Max);
				if (H1 == H2 and H2 == H3 and H3 == H4) {
						break;					
					}
				else if (H2 >= H1 and H2 >= H3 and H2 >= H4) {
					// hledam dal mezi 1 a 3
					Max = Min + (Max-Min)*2/3;
				}
				else if (H3 >= H1 and H3 >= H2 and H3 >= H4) {
					// hledam dal mezi 2 a 4
					Min = Min + (Max-Min)/3;
				}
				else if (H1 >= H2 and H1 >= H3 and H1 >= H4) {
					// hledam dal mezi 1 a 2
					Max = Min + (Max-Min)/3;
				}
				else if (H4 >= H1 and H4 >= H2 and H4 >= H3) {
					// hledam dal mezi 3 a 4
					Min = Min + (Max-Min)*2/3;
				}
				ZlepseniP = 1;
				//cout << "zlepsuju Prah " << Prah << endl;
							
			} while (ZlepseniP && iterace < 20);
			Prah = (Min+Max)/2;	
			Zlepseni = max(ZlepseniZ, ZlepseniP);			
		}
		//cout << "opoustim reward, nove hodnoty Z a P: " << Zapomneni << "  :  " << Prah << endl;
  		
  };     // informace o vysledku soubouje (CC/CD/DC/DD)

	int vycisli(double Z, double P) {
		int Posledni, Soucet, i;
		
		Soucet = 0;

		Posledni = (index-1) % Memory;

 		SimMyRs = new int [Memory];
 		SimHisRs = new int [Memory];
 		for (i = 0; i < Memory ; i++){
  			SimMyRs[i] = MyRs[(index+i)%Memory];
	  		SimHisRs[i] = HisRs[(index+i)%Memory];
	  	}		  	

		// prumer do te doby	(pamatuju si x zpatky a jeste jednou x, abych mohl prave tady simulovat hru)
		// ne ze by to neslo optimalneji...
		SimHisAvg = 0;
		SimMyAvg = 0;
		for (i = 0; i < Memory/2 ; i++) {
			SimHisAvg = (Z*Memory*SimHisAvg + SimHisRs[i]) / Memory;
			SimMyAvg = (Z*Memory*SimMyAvg + SimMyRs[i]) / Memory;						
		}
		
		for ( ; i < Memory ; i++) {
			// simulace hry
			// nase akce:
			if (SimMyAvg >= avgHis-P) last_action = COOPERATE;	 
			else last_action = DECEIVE;

	  		//cout << "kolo: " << i << endl;
			// rozdeleni odmen (samotna hra)
			if (last_action == DECEIVE) {
				if ((HisRs[i] == DD)  || (HisRs[i] == DC)) {			
					// DD
					SimMyRs[i] = DD;
					SimHisRs[i] = DD;
					//cout << DD<< endl;
				}
				else {
					// DC
					SimMyRs[i] = DC;
					SimHisRs[i] = CD;					
					//cout << DC << endl;				
				}
			}
			else {
				if ((HisRs[i] == DD)  || (HisRs[i] == DC)) {
					// CD
					SimMyRs[i] = CD;
					SimHisRs[i] = DC;
					//cout << CD<< endl;
				}
				else {
					// CC				
					SimMyRs[i] = CC;
					SimHisRs[i] = CC;
					//cout << CC<< endl;					
				}			
			}
			
			Soucet += SimMyRs[i];
			//cout << "zatim vycisleno: " << Soucet << endl;
			
			// priprava na dalsi kolo			
			SimHisAvg = (Z*Memory*SimHisAvg + SimHisRs[i]) / Memory;
			SimMyAvg = (Z*Memory*SimMyAvg + SimMyRs[i]) / Memory;						
							
		}
		//cout << "vycisleno: " << Soucet << endl;
		return Soucet;
	}

  virtual void reset() { last_reward = CC; llast_reward = CC;
  cout << "posledni z a p: " << Zapomneni << "  :  " << Prah << endl;
  	cnt = 0;
  	avgMy = 0;
  	avgHis = 0;
  	Zapomneni = 0.8;
  	Prah = 0.1;
  	Memory = 16;
  	HisRs = new int [Memory];
 	MyRs = new int [Memory];
  	for (index = 0; index < Memory ; index++){
  		HisRs[index] = CC;
  		MyRs[index] = CC;
  	}
  	index=0;
  }

  virtual string getName() { return "JesteLepsiStrategie"; }  // pojmenujte si ji  
  
  private:
  	int last_reward, llast_reward, last_action, index, Memory;
  	int *HisRs, *MyRs, *SimHisRs, *SimMyRs;
  	double avgMy, avgHis, SimMyAvg, SimHisAvg, Prah, Zapomneni;
  	int cnt;
}; 



#endif 
