#ifndef LUDEK_CIGLER_STRATEGY_H
#define LUDEK_CIGLER_STRATEGY_H

#include "strategy.h"
#include <iostream>

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class LudekCiglerStrategy : public Strategy { //zmente jmeno tridy 
public:
  LudekCiglerStrategy(): num_rounds(0), num_opponent_deceived(0), num_revenges(0), last_opponent_answer(COOPERATE) {}

  virtual int operator()() {
        if (last_opponent_answer == DECEIVE) {
                num_revenges = 0;
                return DECEIVE;
        } else if (num_rounds > 0 && 
                  ((double)num_opponent_deceived / num_rounds) * (1.0 / (num_revenges + 0.05)) >= 0.5) {
                ++num_revenges;
                return DECEIVE;
        }
        else {
                num_revenges = 0;
                return COOPERATE;
        }
  }; 

  virtual void reward(int _reward) {
        ++num_rounds;
        if (_reward == CD || _reward == DD)
        {
                ++num_opponent_deceived;
                last_opponent_answer = DECEIVE;
        }
        else
        {
                last_opponent_answer = COOPERATE;
        }
  };     // informace o vysledku soubouje (CC/CD/DC/DD)

  virtual void reset() {
          last_opponent_answer = COOPERATE;
          num_rounds = 0;
          num_opponent_deceived = 0;
          num_revenges = 0;
  }

 

  virtual string getName() { return "Ludek_Cigler"; }  // pojmenujte si ji  

private:
  int num_rounds; // How many rounds have we played
  int num_opponent_deceived; // How many times has the opponent deceived so far?
  int num_revenges; // How long was the revenge period so far?
  int last_opponent_answer;
}; 



#endif 
