#ifndef RADEK_STRATEGY_H
#define RADEK_STRATEGY_H
// Radek Krizka 

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class RadekStrategy : public Strategy { //zmente jmeno tridy 
public:

  virtual int operator()() {

	int out;

	// TEST na oplaceni
	if (revengeWait == 1){
		revengeWait = -1;
		if ( lastArray[0] == COOPERATE ) // !!! PROTIVNIK NEOPLACI !!! - odted davam na CCC -> D
			revenge     = 0;  // on neoplaci
		else
			revenge     = 1;  // on oplaci // !!! PROTIVNIK OPLACI !!!
	}
	if ( (lastArray[2] == COOPERATE) && (lastArray[1] == COOPERATE) && (lastArray[0] == COOPERATE) && (revengeWait == 0)){
		revengeWait = 1;
		return DECEIVE;
	}
	
	// TEST na oplaceni CCD - zrada
	if (  (lastArray[2] == COOPERATE) && (lastArray[1] == COOPERATE )   && (lastArray[0] == DECEIVE) ){
    rep++;
  }
	 

	if (  (  (lastArray[2] == COOPERATE) && (lastArray[1] == COOPERATE) && (lastArray[0] == COOPERATE) && (revenge == 1)) ||
/*DDC*/ (  (lastArray[2] == DECEIVE)   && (lastArray[1] == DECEIVE)   && (lastArray[0] == COOPERATE)&& (rep<2))                   || 
/*CDC*/	(  (lastArray[2] == COOPERATE) && (lastArray[1] == DECEIVE)   && (lastArray[0] == COOPERATE)&& (rep<2))                   ||
/*DCC*/	(  (lastArray[2] == DECEIVE)   && (lastArray[1] == COOPERATE) && (lastArray[0] == COOPERATE)&& (rep<2))                   ||
/*CCD*/	(  (lastArray[2] == COOPERATE) && (lastArray[1] == COOPERATE) && (lastArray[0] == DECEIVE)  && (rep<2))    )
		out = COOPERATE;
	else
		out = DECEIVE;

  if ( rep > 1)
    revenge = 0;
	return out;
  } 

/***************************************************************************/

  virtual void reward(int _reward) {
    // informace o vysledku soubouje (CC/CD/DC/DD)

	// prehraju vysledky z minulych kol
	for(int i=count-1; i>0; i--){
		lastArray[i] = lastArray[i-1];
	}
	if (_reward == CC || _reward == DC) 
		lastArray[0] = COOPERATE;
    	else 
		lastArray[0] = DECEIVE;
  } 

/***************************************************************************/
 
  virtual void reset() { 
	revenge     = 1;
	rep         = 0;
	revengeWait = 0;

	for(int i=0; i < count; i++){
 		lastArray[i] = COOPERATE; 
 	}
 	lastArray[1] = DECEIVE; 
}

  virtual string getName() { return "RadekStrategy"; }  // pojmenujte si ji

private:
	static const int count = 5;
	int revengeWait;
	int revenge;
	int rep;
	int lastArray[count];
}; 



#endif 
