#ifndef DM_STRATEGY_H
#define DM_STRATEGY_H

#include "strategy.h"
#include <deque>

#define C 0
#define D 1

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class DM_Strategy : public Strategy { 
private:
  int penalty;
  int prev_r;
  int r;

public:

  DM_Strategy() { reset(); }

  virtual int operator()() {
    if (penalty == 0) {
      if (r == C && prev_r == C) return COOPERATE;
      else {
        penalty = 5;
	return DECEIVE;
      }
    }
    else {
      penalty--;
      return DECEIVE;
    }
  } 

  virtual void reward(int _reward) { // informace o vysledku soubouje (CC/CD/DC/DD)
    prev_r = r;
    r = (_reward == DC || _reward == CC) ? C : D;
  }

  virtual void reset(void)
  {
  r = C;
  prev_r = C;
  penalty = 0;
}

  virtual string getName() { return "DM"; }  // pojmenujte si ji  
}; 



#endif 
