#ifndef MORAJ2AM_STRATEGY_H
#define MORAJ2AM_STRATEGY_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class MORAJ2AMSTRG : public Strategy { //zmente jmeno tridy 
public:

  MORAJ2AMSTRG(){reset();};
 
  virtual int operator()() {
  //pokud rozpozname alter strategii nespolupracujeme
  //jinak se chovame jako Pavlov (resp. CopyPartner)
    if(isAlter) return DECEIVE;
    return last;
  } 

  virtual void reset() {
    //historie souperovych odpovedi
    //(funguje dokola - posledni zaznam ma index "oldest")
    history[0]=-1;
    history[1]=-1;
    history[2]=-1;
    history[3]=-1;
    history[4]=-1;
    history[5]=-1;

    //historie odpovidajici alter strategii
    alterh[0]=1;
    alterh[1]=0;
    alterh[2]=1;
    alterh[3]=0;
    alterh[4]=1;
    alterh[5]=0;

    oldest=0;
    isAlter=false; //souper pouziva alter strategii
    last=COOPERATE; //posledni souperova odpoved
  }

  virtual void reward(int _reward) {
    if(_reward==CD||_reward==DD){last=DECEIVE;}
    if(_reward==CC||_reward==DC){last=COOPERATE;}
    history[oldest]=last;
    oldest++;
    if(oldest>5) oldest=0;

    //odpovida historii alter historie nebo negaci alter historie?
    isAlter=true;
    int i;
    for(i=0;i<=5;i++)
      if(history[i]!=alterh[i]) isAlter=false;
    if(!isAlter){
      isAlter=true;
      for(i=0;i<=5;i++)      
        if(history[i]!=1-alterh[i]) isAlter=false;
    }
	  
  };     // informace o vysledku soubouje (CC/CD/DC/DD)

 

  virtual string getName() { return "moraj2amSTRG"; }  // pojmenujte si ji  

private:
  int oldest;
  int history[6];
  int alterh[6];
  bool isAlter;
  int last;
}; 



#endif 
