#ifndef PAVEL_CESKA_STRATEGY_H
#define PAVEL_CESKA_STRATEGY_H

#include "strategy.h"
#include <deque>

#define HISTORY_LEN  2

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class MyStrategy_pavel_ceska : public Strategy { //zmente jmeno tridy 
private:
  deque<int> historie;

public:
  MyStrategy_pavel_ceska() { reset(); }
  
  virtual int operator()() { 
    switch (historie[0]*10 + historie[1])
    {
      case 00:  return DECEIVE;
      case 01:  return DECEIVE;
      case 03:  return COOPERATE;
      case 05:  return DECEIVE;

      case 10:  return DECEIVE;
      case 11:  return COOPERATE;
      case 13:  return DECEIVE;
      case 15:  return DECEIVE;
      
      case 30:  return DECEIVE;
      case 31:  return DECEIVE;
      case 33:  return COOPERATE;
      case 35:  return DECEIVE;
      
      case 50:  return DECEIVE;
      case 51:  return DECEIVE;
      case 53:  return COOPERATE;
      case 55:  return COOPERATE;
    }
    return COOPERATE;
  } 

  virtual void reward(int _reward)
  {
    historie.push_back(_reward);
    if (historie.size() > HISTORY_LEN)
      historie.pop_front();
  };     // informace o vysledku soubouje (CC/CD/DC/DD)

  virtual void reset(void)
  {
    for (int i = 0; i < HISTORY_LEN; i++) { historie[i] = CC; }
  }

  virtual string getName() { return "Pavel_Ceska_Strategy"; }  // pojmenujte si ji  
}; 



#endif 
